%     VIRTUAL FABRIC - программа для получения эффективных свойств текстильных композитов
%     Copyright (C) 2020  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function [NODES, ELEMENTS] = Merge_Nodes(NODES_input, ELEMENTS_input, Node_Merge_Tolerance)

Candidates_Table_Initial_Size = 10;

N_Nodes = size(NODES_input,1);

Max_Node_Number = 0;

for i=1:N_Nodes

    if (NODES_input(i,1) > Max_Node_Number)

        Max_Node_Number = NODES_input(i,1);

    end

end

AT_NODES = zeros(Max_Node_Number, 1);

for i=1:N_Nodes
    
    AT_NODES(NODES_input(i,1)) = i;
    
end

Candidates_Table = zeros(N_Nodes, Candidates_Table_Initial_Size);

Nodes_Sort_X = sortrows(NODES_input,2);

Merge_Flags = zeros(Max_Node_Number,1);

counter_1 = 0;

for i=1:N_Nodes
    
    if (Merge_Flags(NODES_input(i,1)) == 1)
        continue;
    end
    
    Temp_Nodes = Find_Nodes(Nodes_Sort_X, NODES_input(i,:), Node_Merge_Tolerance, 2);
    
    Temp_Nodes = sortrows(Temp_Nodes,3);
    
    Temp_Nodes = Find_Nodes(Temp_Nodes, NODES_input(i,:), Node_Merge_Tolerance, 3);
    
    Temp_Nodes = sortrows(Temp_Nodes,4);
    
    Temp_Nodes = Find_Nodes(Temp_Nodes, NODES_input(i,:), Node_Merge_Tolerance, 4);
    
    for j=1:size(Temp_Nodes,1)
        
        Merge_Flags(Temp_Nodes(j,1)) = 1;
        
    end
    
    counter_1 = counter_1 + 1;
    
    Candidates_Table(counter_1, 1) = NODES_input(i,1);
    
    counter_2 = 1;
    
    for j=1:size(Temp_Nodes,1)
        
        if (Temp_Nodes(j,1) == NODES_input(i,1))
            continue;
        end
        
        counter_2 = counter_2 + 1;
        
        Candidates_Table(counter_1, counter_2) = Temp_Nodes(j,1);
        
    end

end

Candidates_Table = sort(Candidates_Table,2,'descend');

Candidates_Table = sortrows(Candidates_Table,1);

for i=1:size(Candidates_Table,1)
    
    if (Candidates_Table(i,1) > 0)
        
        index = i;
        break;
        
    end
    
end

counter = 1;

temp = Candidates_Table(index,1);

for i=index+1:size(Candidates_Table)
    
    if (Candidates_Table(i,1) > temp)
        
        counter = counter + 1;
        
        temp = Candidates_Table(i,1);
        
    end
    
end

Candidates_Table_2 = zeros(counter, size(Candidates_Table,2));

counter = 1;

temp = Candidates_Table(index,1);

Candidates_Table_2(1,:) = Candidates_Table(index,:);

for i=index+1:size(Candidates_Table)
    
    if (Candidates_Table(i,1) > temp)
        
        counter = counter + 1;
        
        Candidates_Table_2(counter,:) = Candidates_Table(i,:);
        
        temp = Candidates_Table(i,1);
                
    end
    
end

NODES = zeros(size(Candidates_Table_2, 1), 4);

for i=1:size(NODES,1)
    
    NODES(i,1) = i;
    
end

Replacement_Table = zeros(Max_Node_Number, 1);

for i=1:N_Nodes
    
    Replacement_Table(NODES_input(i,1)) = NODES_input(i,1);
    
end

for i=1:size(Candidates_Table_2,1)
    
    NODES(i,2:4) = NODES_input(AT_NODES(Candidates_Table_2(i,1)), 2:4);
    
    for j=1:size(Candidates_Table_2,2)
        
        if (Candidates_Table_2(i,j) == 0)
            break;
        end
        
        Replacement_Table(Candidates_Table_2(i,j)) = i;
        
    end
    
end

ELEMENTS = ELEMENTS_input;

for i=1:size(ELEMENTS,1)
    
    for j=5:5+ELEMENTS(i,3)-1
        
        ELEMENTS(i,j) = Replacement_Table(ELEMENTS(i,j));
        
    end
    
end
